"use strict";
// A loose Typescript interpretation of the JSON spec from
// http://www.ecma-international.org/publications/files/ECMA-ST/ECMA-404.pdf
Object.defineProperty(exports, "__esModule", { value: true });
exports.InternalTypeSymbol = Symbol("InternalType");
const stringConstructor = (options = {}) => {
    return Object.assign(Object.assign({ type: "string" }, options), { [exports.InternalTypeSymbol]: {} });
};
const numberConstructor = (options = {}) => {
    return Object.assign(Object.assign({ type: "number" }, options), { [exports.InternalTypeSymbol]: {} });
};
const integerConstructor = (options = {}) => {
    return Object.assign(Object.assign({ type: "integer" }, options), { [exports.InternalTypeSymbol]: {} });
};
const objectConstructor = (options) => {
    return Object.assign(Object.assign({ type: "object" }, options), { [exports.InternalTypeSymbol]: {} });
};
const arrayConstructor = (options = {}) => {
    return Object.assign(Object.assign({ type: "array" }, options), { [exports.InternalTypeSymbol]: {} });
};
const booleanConstructor = (options = {}) => {
    return Object.assign(Object.assign({ type: "boolean" }, options), { [exports.InternalTypeSymbol]: {} });
};
const nullConstructor = (options = {}) => {
    return Object.assign(Object.assign({ type: "null" }, options), { [exports.InternalTypeSymbol]: {} });
};
// TODO: union of enum types not working for anyof/allof.
// I want
// typeof allOfConstructor({
//   allOf: [
//     Type.String({ enum: ["a", "b"] }),
//     Type.String({ enum: ["a", "b", "c"] })
//   ]
// })[InternalTypeSymbol];
// to be "a" | "b", but right now it's just string
const anyOfConstructor = (options) => {
    return Object.assign(Object.assign({}, options), { [exports.InternalTypeSymbol]: {} });
};
const allOfConstructor = (options) => {
    return Object.assign(Object.assign({}, options), { [exports.InternalTypeSymbol]: {} });
};
exports.Schema = {
    String: stringConstructor,
    Number: numberConstructor,
    Integer: integerConstructor,
    Object: objectConstructor,
    Array: arrayConstructor,
    Boolean: booleanConstructor,
    Null: nullConstructor,
    AnyOf: anyOfConstructor,
    AllOf: allOfConstructor
};
